//@author: 
//@help: 
//@tags: 
//@credits: 


float4x4 tW0 : WORLDd;
//float4x4 tVP0 : VIEWPROJECTION;
//float4x4 tWVP : WORLDVIEWPROJECTION;
//float4x4 tWV : WORLDVIEW;

float balance=0;
float smoothMin=0;
float smoothMax=0;
float circleRadius=1;
float circleWidth=1;
float2 circleCenter= float2(0,0);
float circleSmooth=0.01;

float decay;
float blendValue;

float circle(in float2 _st, in float _radius, in float _width){
    float2 dist = _st-circleCenter;
	float radius2 = _radius + _width;
	return smoothstep(_radius-(_radius*circleSmooth), _radius+(_radius*circleSmooth), dot(dist,dist)*4) -
	smoothstep(radius2-(circleSmooth), radius2+(radius2*circleSmooth), dot(dist,dist)*4);
}

struct vsInputTextured
{
    float4 posObject : POSITION;
	float4 uv: TEXCOORD0;
};

struct psInputTextured
{
    float4 posScreen : SV_Position;
    float4 posWorld : POSITION;
    float4 uv: TEXCOORD0;
};

Texture2D previousTexture <string uiname="PreviousTexture";>;

SamplerState linearSampler <string uiname="Sampler State";>
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

cbuffer cbPerDraw : register(b0)
{
	float4x4 tVP : LAYERVIEWPROJECTION;
};

cbuffer cbPerObj : register( b1 )
{
	float4x4 tW : WORLD;
//	float Alpha <float uimin=0.0; float uimax=1.0;> = 1; 
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
	float4x4 tColor <string uiname="Color Transform";>;
};

cbuffer cbTextureData : register(b2)
{
	float4x4 tTex <string uiname="Texture Transform"; bool uvspace=true; >;
};

psInputTextured VS_UVTexture(vsInputTextured input)
{
	psInputTextured output;
//	output.posScreen = input.posObject * float4(2,2,1,1);
	output.posScreen = float4((input.uv.xy-0.5)*2*float2(1,-1),0,1);
//	output.posScreen = mul(input.posObject,mul(tW,tVP));
	output.posWorld = mul(input.posObject,tW);
	output.uv = mul(input.uv, tTex);
	return output;
}

float4 PS_SIN_POSWOLRD_CIRCULAR(psInputTextured input): SV_Target
{
    float4 col = cAmb;
//	col = mul(col, tColor);
	
	float4 previous = previousTexture.Sample(linearSampler,input.uv.xy);

	float circleValue = smoothstep(smoothMin,smoothMax, circle(input.posWorld.xz,circleRadius,circleWidth)+balance);
	
	col.a = max(previous.a - (1 - decay), circleValue);

//	float newValue = lerp(previous.r- decay,circleValue, blendValue);
	float newValue = circleValue;
//	newValue = 0.3;
//	newValue = 1;
	col = float4(newValue,newValue,newValue,1);
	
    return col;
}

technique11 SinWorldPosCircularUVTexture
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS_UVTexture() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_SIN_POSWOLRD_CIRCULAR() ) );
	}
}