//@author: 
//@help: 
//@tags: 
//@credits: 


float4x4 tW0 : WORLDd;
//float4x4 tVP0 : VIEWPROJECTION;
//float4x4 tWVP : WORLDVIEWPROJECTION;
//float4x4 tWV : WORLDVIEW;

float balance=0;
float smoothMin=0;
float smoothMax=0;

float frequency;
float shift;

struct vsInputTextured
{
    float4 posObject : POSITION;
	float4 uv: TEXCOORD0;
};

struct psInputTextured
{
    float4 posScreen : SV_Position;
    float4 posWorld : POSITION;
    float4 uv: TEXCOORD0;
};

Texture2D previousTexture <string uiname="PreviousTexture";>;

SamplerState linearSampler <string uiname="Sampler State";>
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

cbuffer cbPerDraw : register(b0)
{
	float4x4 tVP : LAYERVIEWPROJECTION;
};

cbuffer cbPerObj : register( b1 )
{
	float4x4 tW : WORLD;
	float Alpha <float uimin=0.0; float uimax=1.0;> = 1; 
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
	float4x4 tColor <string uiname="Color Transform";>;
};

cbuffer cbTextureData : register(b2)
{
	float4x4 tTex <string uiname="Texture Transform"; bool uvspace=true; >;
};


psInputTextured VS(vsInputTextured input)
{
	psInputTextured output;
//	output.posScreen = float4((input.uv.xy-0.5)*2*float2(1,-1),0,1); // UV coordinates
	output.posScreen = mul(input.posObject,mul(tW,tVP)); // default
	output.posWorld = mul(input.posObject,tW);
	output.uv = mul(input.uv, tTex);
	return output;
}

psInputTextured VS_UVTexture(vsInputTextured input)
{
	psInputTextured output;
	output.posScreen = float4((input.uv.xy-0.5)*2*float2(1,-1),0,1); // UV coordinates
//	output.posScreen = mul(input.posObject,mul(tW,tVP)); // default
	output.posWorld = mul(input.posObject,tW);
	output.uv = mul(input.uv, tTex);
	return output;
}

float4 PS(psInputTextured input): SV_Target
{
    float4 col = cAmb;
	col = mul(col, tColor);
	col.a *= Alpha * smoothstep(smoothMin,smoothMax,sin(input.posWorld.z * frequency + shift)+balance) ;
	return col;
}

technique11 standard
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}

technique11 uv_texture
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS_UVTexture() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}